# Get offers for server request

Ingest an event and receive personalization response from RT engine.

Endpoint: POST /{database}/{table}
Version: 1.0
Security: td1, wp13n

## Path parameters:

  - `database` (string, required)
    name of the destination database
    Example: "alpha"

  - `table` (string, required)
    name of the destination table
    Example: "bravo"

## Request fields (application/vnd.treasuredata.v1+json):

  - `time` (integer, required)
    Time in seconds since Epoch. Must be between 00:00:00 1 Jan 1970 UTC and 23:59:59 31 Dec 9999 UTC.
    Example: 1647376522

  - `uuid` (string, required)
    ID of the record in [UUID](https://docs.oracle.com/javase/7/docs/api/java/util/UUID.html) format.
    Example: "b82aad42-481b-4ca7-87c0-848a34f3c85f"

## Response 400 fields (application/json):

  - `code` (integer, required)
    Error Code for engineer identification. The following are used:

3000: RT token was not provided (WP13n-Token header).
3001: RT token is not in configuration.
3002: RT token account conflicts with Authed user account.
3003: RT token is in an invalid format.
3004: Invalid event object.
3005: Request origin not in IP whitelist.
3006: Invalid token type. Token type is not matching the one in the configuration.
3007: Invalid or missing Origin.
3008: Request method is required.
3009: Unsupported method.
    Enum: 3000, 3001, 3002, 3003, 3004, 3005, 3006, 3007, 3008, 3009

  - `message` (string)
    General explanation for users

## Response 429 fields (application/json):

  - `code` (integer, required)
    Error Code for engineer identification. The following are used:

2003: Kinesis error due to limit being exceeded (status 429)
2013: Lambda total concurrent execution exceeds the reserved concurrency (status 429)
    Enum: 2003, 2013

  - `message` (string)
    General explanation for users

## Response 500 fields (application/json):

  - `code` (integer, required)
    Error Code for engineer identification. The following are used:

9999: Unknown/undiagnosed
1001: TD API is unreachable or timed out
1002: Table API is unreachable or timed out
1003: Kinesis is unreachable or timed out
1004: Lambda is unreachable or timed out
1005: MemoryDB is unreachable or timed out
2001: Kinesis stream was not found
2002: Kinesis operation threw an error
2011: Lambda function was not found
2012: Lambda function threw an error, or response was unhandled
2014: Lambda invocation failed
2015: Lambda reactor configuration doesn't have the token yet
2021: MemoryDB operation threw an error
3010: RT Token is configured with a reactor whose token is inconsistent (account or reactor ID mismatch)
3011: RT Token is configured with a reactor whose name is inconsistent (site or stage different from this API)
3012: RT Token is configured with a reactor whose name is completely invalid
3013: Unable to retrieve Client IP from request
    Enum: 1001, 1002, 1003, 1004, 1005, 2001, 2002, 2011, 2012, 2014, 2015, 2021, 3010, 3011, 3012, 3013, 9999

  - `message` (string)
    General explanation for users


## Response 200 fields
